* -------------------------------
* 	LPS Example
*
* 	Allocazione Statica
*
*	Language: MC68K-ASM1
*	Style: plain MC68000
* 	Version: Ref-m68k
* -------------------------------

* Complete Example

* Questo esempio mostra
* 1) Allocazione statica dei dati attraverso direttive di definizione dati in MIPS32
* 2) Uso di espressioni aritmetiche con label e numeri per esprimere indirizzi
* 3) Esempi di uso delle istruzioni di trasferimento dati

* Gli studenti sono invitati a esaminare il programma e svolgere i seguenti
* esercizi. Si provi a pensare alla risposta giusta, e poi a verificarla
* eseguendo il programma.
* a) A quale indirizzo e' legata la label "inizio_dati"?
* b) La differenza "lab2-inizio_dati" vale 17. Spiegare perche'
* c) Quanto vale la differenza "lab4-inizio_dati"?
* d) Una delle direttive di definizione dati definisce una word con valore 666.
*	Qual'e' l'indirizzo di memoria di tale word?
* e) L'istruzione move.w #$0605,inizio_dati+12 scrive un valore in una word, 
*	sovrascrivendo il valore iniziale. Qual'e' tale valore iniziale?
* f.1) I 4 byte di indirizzi lab1, lab2, lab3, lab4 vengono letti come una
*	unica long dall'istruzione move.l lab1,d0. Qual'e' il valore che tale
*	istruzione scrive in d0?
* f.2) I 2 byte di indirizzi lab6 e lab7 vengono letti come una
*	unica word dall'istruzione move.w lab6,d1. Qual'e' il valore che tale
*	istruzione scrive in d1? 
* f.3) I 2 byte di indirizzi lab6 e lab7 vengono letti come una
*	unica word dall'istruzione move.w lab6,a1. Qual'e' il valore che tale
*	istruzione scrive in a1? 
*	Per rispondere alle 3 domande f, si tenga conto che MC68000
*	organizza la memoria in modo big-endian.


* Questo esempio e' realizzato per l'assembler ASM-One V1.48
* Per eseguire il programma si puo' usare dalla CLI di ASM-One il comando g
; indicando "inizio_codice" come indirizzo iniziale e "fine_codice" come breakpoint 

* Sezione Dati: l'indirizzo di inizio della sezione e' $2080
	org	$2080
inizio_dati:
	dc.l	1,2,6
	dc.w	666,5
lab1:	dc.b	1	
lab2:	dc.b	2	
lab3:	dc.b	3	
lab4:	dc.b	4	
lab5:	dc.l	7
lab6:	dc.b	$80
lab7:	dc.b	$08


* Sezione Codice: l'indirizzo di inizio della sezione e' $2000
	org	$2000
inizio_codice:


* scrittura in memoria
	move.l	#$73727170,inizio_dati

	move.w	#$0605,inizio_dati+12

* copia memoria-memoria: il contenuto della long di indirizzo lab5
* 	viene copiata nella long di indirizzo pari a inizio_dati+4
	move.l	lab5,inizio_dati+4

* operazioni aritmetiche con operando in memoria: il contenuto della word
*	di indirizzo pari a inizio_dati+14 viene aumentato di 3
	add.w	#3,inizio_dati+14

* endianess
	move.l	lab1,d0
	move.w	lab6,d1
	move.w	lab6,a1
	
fine_codice:

