# -------------------------------
# 	LPS Example
#
# 	Allocazione Statica
#
#	Language: MIPS32-MARS
#	Style: plain MIPS32
# 	Version: Ref-mips
# -------------------------------

# Complete Example

# Questo esempio mostra
# 1) Allocazione statica dei dati attraverso direttive di definizione dati in MIPS32
# 2) Uso di espressioni aritmetiche con label e numeri per esprimere indirizzi
# 3) Esempi di uso delle istruzioni di trasferimento dati

# Gli studenti sono invitati a esaminare il programma e svolgere i seguenti
# esercizi. Si provi a pensare alla risposta giusta, e poi a verificarla
# eseguendo il programma.
# a) A quale indirizzo e' legata la label "inizio_dati"?
# b) La label "lab2" e' legata all'indirizzo 0x10011011. Spiegare perche'
# c) A quale indirizzo e' legata la label "lab4"?
# d) Una delle direttive di definizione dati definisce una half con valore 666.
#	Qual'e' l'indirizzo di memoria di tale half?
# e) L'istruzione sh $t1,inizio_dati+12 scrive un valore in una half, 
#	sovrascrivendo il valore iniziale. Qual'e' tale valore iniziale?
# f.1) I 4 byte di indirizzi lab1, lab2, lab3, lab4 vengono letti come una
#	unica word dall'istruzione lw $s0,lab1. Qual'e' il valore che tale
#	istruzione scrive in $s0?
# f.2) I 2 byte di indirizzi lab6 e lab7 vengono letti come una
#	unica half dall'istruzione lh $s1,lab6. Qual'e' il valore che tale
#	istruzione scrive in $s1? 
# f.3) I 2 byte di indirizzi lab6 e lab7 vengono letti come una
#	unica half dall'istruzione lhu $s2,lab6. Qual'e' il valore che tale
#	istruzione scrive in $s2? 
#	Per rispondere alle 3 domande f, si tenga conto che MARS
#	organizza la memoria in modo little-endian.

# Questo esempio e' realizzato per l'assembler MARS
# Per eseguire il programma si possono usare i comandi della GUI

# Sezione Dati: viene specificato un indirizzo di inizio della sezione
# (MARS lo permette in quanto non vi e' un SO)
	.data	0x10011000

inizio_dati:	
	.word	1,2,6
	.half	666,5
lab1:	.byte	1
lab2:	.byte	2
lab3:	.byte	3
lab4:	.byte	4
lab5:	.word	7
lab6:	.byte	0x08
lab7:	.byte	0x80

# Sezione Codice: in questo caso non viene specificato l'indirizzo di
# inizio sezione, e quindi sara' MARS a stabilirlo automaticamente
	.text

# scrittura in memoria
	li	$t0,0x73727170
	sw	$t0,inizio_dati

	li	$t1,0x06050605
	sh	$t1,inizio_dati+12

# copia memoria-memoria: il contenuto della word di indirizzo lab5
# 	viene copiata nella word di indirizzo pari a inizio_dati+4
	lw	$t2,lab5
	sw	$t2,inizio_dati+4

# operazioni aritmetiche con operando in memoria: il contenuto della half
#	di indirizzo pari a inizio_dati+14 viene aumentato di 3
	lh	$t3,inizio_dati+14
	add	$t3,$t3,3
	sh	$t3,inizio_dati+14
 
# endianess
	lw	$s0,lab1
	lh 	$s1,lab6
	lhu 	$s2,lab6
	
	
